import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class UDPClient extends PApplet {

int portServer    = 6100 ;            // could be moved to setup
String hostServer = "localhost" ;     // could be moved to setup
java.net.DatagramPacket packetToSend ;

int portClient ;
java.net.DatagramSocket sockSend ;
int msgNumber = 0;

PFont msgFont ;
String[] messages = {"", "", "", "", "", "", ""} ;

public void setup() {
  java.net.SocketAddress addrServer ;
  size(600, 400) ;
  background(0,0,127) ;
  msgFont = loadFont("SansSerif.plain-24.vlw") ;
  textFont(msgFont) ;
  try {
    sockSend = new java.net.DatagramSocket() ;
    portClient = sockSend.getLocalPort() ;
    messages[0] = "Client UDP port:  " + portClient ;
    addrServer = new java.net.InetSocketAddress(hostServer, portServer) ;
    packetToSend = new java.net.DatagramPacket(new byte[0], 0, addrServer) ;
  } catch (java.net.SocketException se) {
    sockSend = null ;
    portClient = 0 ;
    packetToSend = null ;
    messages[0] = "Unable to open UDP socket" ;
  }
}

public void draw() {
  delay(3500) ;
  background(0,0,127) ;
  String nextMessage = "Message number " + msgNumber ;
  ++msgNumber ;
  for (int i=messages.length-1; i>0; --i) {
    messages[i] = messages[i-1] ;
  }
  messages[0] = "Sending:  " + nextMessage ;
  for (int i=0; i<messages.length; ++i) {
    text(messages[i], 50, 50+50*i) ;
  }
  byte[] msgBytes = nextMessage.getBytes() ;
  packetToSend.setData(msgBytes) ;
  packetToSend.setLength(msgBytes.length) ;
  try {
    sockSend.send(packetToSend) ;
  } catch (java.io.IOException ioe) {
  }    
}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "UDPClient" });
  }
}
